##########################################################################
#
#  lqirssi.r
#
#  A lot of plot and test function about lqi rssi in all xps
#
##########################################################################

##########################################################################
#     Helper functions
##########################################################################
getTimeSlices <-function(timeValues,cnt) {


  pr <- 8000
  mint <- min(timeValues)
  maxt <- max(timeValues)
  bi<-0
  bs<-0
  step <- 0
  retList <-list()


  goon <- T
    while (goon){
      cntBeforeStep <- length(timeValues[timeValues > bi & timeValues < bs])
      cntAfterStep <- length(timeValues[timeValues > bi & timeValues < bs+pr])
      if ((cntBeforeStep != 0) & (cntBeforeStep == cntAfterStep) ){
        step <- step + 1
        retList[[step]] <- c(bi,bs)
        bi<-bs
      } else {
        if (bs > maxt) {
          retList[[step]] <- c(bi,bs)
          bi<-bs
          goon=F;;
        } else {
          bs<-bs+pr
        }
      }

    }

    retList
}

getTimeSlicesInside <- function(cnt=60) {
    getTimeSlices(inpIn$time,cnt)
}
getTimeSlicesOutside <- function(cnt=40) {
    getTimeSlices(inpOut$time,cnt)
}

##########################################################################
#     RSSI - VAR - MEAN
##########################################################################

tableRssiSymmetryBib1 <- function() {
  m <- tableRssiMeanBib1(1:100)
  d <- matrix(0,20,20)
  for (i in 1:19) {
    for (j in (i+1):20) {
      d[i,j] <- abs(m[i,j] - m[j,i])
      d[j,i] <- d[i,j]
    }
  }
  d
}

tableRssiSymmetrySer <- function() {
  m <- tableRssiMeanSer(1:100)
  d <- matrix(0,20,20)
  for (i in 1:19) {
    for (j in (i+1):20) {
      d[i,j] <- abs(m[i,j] - m[j,i])
      d[j,i] <- d[i,j]
    }
  }
  d
}

tableRssiVarianceBib1 <- function(){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- bib1$rssi[bib1$src==i & bib1$pongsrc==j & bib1$time <=25]
        if (length(sel) != 0) {
          m[i,j] <- round(var(sel),2)
        }
      }
    }
  }
  m
}

tableRssiVarianceSer <- function(){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- ser$rssi[ser$src==i & ser$pongsrc==j & ser$time <=25]
        if( length(sel) != 0 ){
          m[i,j] <- round(var(sel),2)
        }
      }
    }
  }
  m
}

tableRssiMeanBib1 <- function(samples=1:10){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- bib1$rssi[bib1$src==i & bib1$pongsrc==j & bib1$time <=25]
        if( length(sel) != 0 ){
          sel2 <- sel[samples]
          m[i,j] <- round(mean(sel2),2)
        }
      }
    }
  }
  m
}

tableRssiMeanSer <- function(samples=1:10){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- ser$rssi[ser$src==i & ser$pongsrc==j & ser$time <=25]
        if( length(sel) != 0 ){
          sel2 <- sel[samples]
          m[i,j] <- round(mean(sel2),2)
        }
      }
    }
  }
  m[,9] <- 0
  m
}

plotVarRssiSerBib1 <- function(){
  x<-numeric(400)
  y<-numeric(400)
  for (i in 1:20) {
    for (j in 1:20) {
      x[i+20*(j-1)] <- i
      y[i+20*(j-1)] <- j
    }
  }

  t1 <- tableRssiVarianceSer()
  t2 <- tableRssiVarianceBib1()

  t1 = t1/max(t1)
  t2 = t2/max(t2)

  #browser()

  pdf("var_rssi_BIB1.pdf")
  symbols(x[1:400], y[1:400], circles=t1[1:400], inches=FALSE,
        main="rssi var all node to all nodes SER", xlab="node id from", ylab="node id to")
  abline(a=0,b=1)
  dev.off()

  pdf("var_rssi_SER.pdf")
  symbols(x[1:400], y[1:400], circles=t2[1:400], inches=FALSE,
        main="rssi var all node to all nodes BIB1", xlab="node id from", ylab="node id to")
  abline(a=0,b=1)
  dev.off()

}

plotMeanRssiSerBib1 <- function(sel=1:100){
  x <- seq(1, 20)
  y <- x

  lqiSerVar <- tableRssiMeanSer(sel)
  pdf("mean_rssi_SER.pdf")
  persp(x, y, lqiSerVar, theta = 30, phi = 30, expand = 0.5, col = "grey80",
  ltheta = 120, shade = 0.75, ticktype = "detailed",
  xlab = "node id A", ylab = "node id B", zlab = "var lqi",
  main="rssi mean all node to all nodes SER")
  dev.off()
  

  lqiSerVar <- tableRssiMeanBib1(sel)
  pdf("mean_rssi_BIB1.pdf")
  persp(x, y, lqiSerVar, theta = 30, phi = 30, expand = 0.5, col = "grey80",
  ltheta = 120, shade = 0.75, ticktype = "detailed",
  xlab = "node id A", ylab = "node id B", zlab = "var lqi" ,
  main="rssi mean all node to all nodes BIB1")
  dev.off()
}



plotRssiVarianceDistBib1 <- function() {
 rs <- numeric()
 di <- numeric()
 cnt <- 0
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- bib1$rssi[bib1$src==i & bib1$pongsrc==j & bib1$time <=25]
        if (length(sel) > 0) {
          rs[cnt] <- var(sel)
          di[cnt] <- distanceBib1(i,j)
          cnt<-cnt+1
        }
      }
    }
  }
  pdf("rssi_var_vs_dist_BIB1.pdf")
  plot(rs,di,pch='+',main="rssi variance vs distance BIB1 25h",xlab="rssi var",ylab="dist")
  dev.off()
}

plotRssiSymmetry3D <- function() {
  x <- seq(1, 20)
  y <- x

  se <- tableRssiSymmetrySer()
  bi <- tableRssiSymmetryBib1()

  #se <- se / max(se)
  #bi <- bi / max(bi)

  #browser()

  pdf("rssi_symmetry_SER_3D.pdf")
  persp(x, y, se, theta = -45, phi = 45, expand = 0.5, col = "grey80",
  ltheta = -45, shade = 0.50, ticktype = "detailed",zlim=c(0,10),
  xlab = "node id A", ylab = "node id B", zlab = "assimetry |A-B|",
  main="rssi symmetry all node to all nodes SER")
  dev.off()

  pdf("rssi_symmetry_BIB1_3D.pdf")
 persp(x, y, bi, theta = -45, phi = 45, expand = 0.5, col = "grey80",
  ltheta = -45, shade = 0.50, ticktype = "detailed",zlim=c(0,10),
  xlab = "node id A", ylab = "node id B", zlab = "assimetry |A-B|",
  main="rssi symmetry all node to all nodes BIB1")
  dev.off()

}

plotRssiSymmetry <- function() {
  val.se <- numeric()
  val.bi <- numeric()
  se <- tableRssiMeanSer()
  bi <- tableRssiMeanBib1()

  MID<-190
  cnt <- 1

  for (i in 1:19) {
    for (j in (i+1):20) {
      if(se[i,j] > se[j,i]) {
        val.se[MID-cnt] <- se[i,j] - se[j,i]
        val.se[MID+cnt] <- 0
      } else {
        val.se[MID+cnt] <- se[j,i] - se[i,j]
        val.se[MID-cnt] <-0
      }

      if(bi[i,j] > bi[j,i]) {
        val.bi[MID-cnt] <- bi[i,j] - bi[j,i]
        val.bi[MID+cnt] <- 0
      } else {
        val.bi[MID+cnt] <- bi[j,i] - bi[i,j]
        val.bi[MID-cnt] <-0
      }

      cnt <- cnt + 1
    }

  }

  pdf("rssi_symmetry.pdf")
  par(mfrow=c(2,1))

  plot(val.se,type="l",main="symmtrie rssi SER",col="blue1",ylim=c(0,10))
  abline(v=190,col="red1",lty=3)

  plot(val.bi,type="l",main="symmtrie rssi BIB1",col="blue1",ylim=c(0,10))
  abline(v=190,col="red1",lty=3)
  dev.off()


}


##########################################################################
#     RSSI - TIME
##########################################################################
plotRssiTimeInsideAll <- function() {
    timeValues <- inpIn$time-min(inpIn$time)

    lis <- getTimeSlicesInside()

    postscript("plotRssiTimeInsideAll.ps")
    plot(inpIn$rssi,timeValues,col="red1",pch="+",main="rssi vs time  INSIDE ALL radiolevels",xlab="rssi",ylab="time")
    for(i in 1:length(lis)) {
      abline(h=lis[[i]][1])
      text(77,lis[[i]][1],i)
    }
    dev.off()
}

plotRssiTimeInside <- function(radio = rbind(31,27,23,19,15,11,7,3)){
  for (i in 1:length(radio)) {
    sel <- inpIn$radioLevel == radio[i,1]

    timeValues <- inpIn$time[sel]-min(inpIn$time[sel])
    rssiValues <-  inpIn$rssi[sel]

    postscript(paste("plotRssiTimeInside",radio[i,1],".ps"))
    plot(rssiValues,timeValues,col="red1",pch="+",ylim=c(0,5000000),main=paste("rssi vs time INSIDE @ radiolevel",radio[i,1]),xlab="rssi",ylab="time")
    dev.off()

  }
}

plotRssiTimeOutsideAll <- function() {
  timeValues <- inpOut$time-min(inpOut$time)

  lis <- getTimeSlicesOutside()

  postscript("plotRssiTimeOutsideAll.ps")
  plot(inpOut$rssi,timeValues,col="red1",pch="+",main="rssi vs time  OUTSIDE ALL radiolevels",xlab="rssi",ylab="time")
  for(i in 1:length(lis)) {
    abline(h=lis[[i]][1])
    text(80,lis[[i]][1],i)
  }
  dev.off()
}



plotRssiTimeOutside <- function(radio = rbind(31,27,23,19,15,11,7,3)){
  for (i in 1:length(radio)) {
    sel <- inpOut$radioLevel == radio[i,1]

    timeValues <- inpOut$time[sel]-min(inpOut$time[sel])
    rssiValues <-  inpOut$rssi[sel]

    postscript(paste("plotRssiTimeOutside",radio[i,1],".ps"))
    plot(rssiValues,timeValues,col="red1",pch="+",main=paste("rssi vs time  OUTSIDE @ radiolevel",radio[i,1]),xlab="rssi",ylab="time")
    dev.off()
  }
}


plotRssiTimeSer<-function(from=c(2,3,4),to=c(19,15,6)) {
  pdf("rssi_time_SER.pdf")
  par(mfrow=c(length(from),1))

  for (i in 1:length(from)) {

    sel <- ser$src==from[i] & ser$pongsrc==to[i]
    rssis <- ser$rssi[sel]
    times <- ser$time[sel]

    #browser()
    plot(times,rssis,
    xlab="temps(h)",ylab="rssi",
    xlim=c(0,60),
    ylim=c(220,240),
    col=hsv(i/length(from),.8,1),
    pch="+",
    main=paste("rssi - temps noeuds",from[i],"->",to[i],"SER")
    );
  }
  dev.off()
}

plotRssiTimeBib1<-function(from=c(7,8,9),to=c(10,11,12)) {
  pdf("rssi_time_BIB1.pdf")
  par(mfrow=c(length(from),1))

  for (i in 1:length(from)) {

    sel <- bib1$src==from[i] & bib1$pongsrc==to[i]
    rssis <- bib1$rssi[sel]
    times <- bib1$time[sel]

    #browser()
    plot(times,rssis,
    xlab="temps(h)",ylab="rssi",
    xlim=c(0,60),
    ylim=c(220,240),
    col=hsv(i/length(from),.8,1),
    pch="+",
    main=paste("rssi - temps noeuds",from[i],"->",to[i],"BIB1")
    );
  }
  dev.off()
}



##########################################################################
#     RSSI - DISTANCE
##########################################################################
getRssiDistMatInside <-function(rl=31) {
  sel <- inpIn$radioLevel == rl

  timeValues <- inpIn$time[sel]-min(inpIn$time[sel])
  rssiValues <- inpIn$rssi[sel]

  retList <- list()
  slices <- getTimeSlicesInside()
  for (i in 1:length(slices)) {
    tmp <- rssiValues[timeValues > slices[[i]][1] & timeValues < slices[[i]][2]]
    if (length(tmp) == 0) {
        retList[[i]] <- c(0,0)
    } else {
      retList[[i]] <- tmp
    }
  }
  retList
}

getRssiDistMatOutside <-function(rl=31) {
  sel <- inpOut$radioLevel == rl

  timeValues <- inpOut$time[sel]-min(inpOut$time[sel])
  rssiValues <- inpOut$rssi[sel]

  retList <- list()
  slices <- getTimeSlicesOutside()
  for (i in 1:length(slices)) {
    tmp <- rssiValues[timeValues > slices[[i]][1] & timeValues < slices[[i]][2]]
    if (length(tmp) == 0) {
      retList[[i]] <- c(0,0)
    } else {
      retList[[i]] <- tmp
    }
  }
  retList
}

plotRssiDistInside <-function(radio = rbind(31,27,23,19,15,11,7,3)) {
  for (ii in 1:length(radio)) {
    #browser()

    dm <- getRssiDistMatInside(radio[ii,1])

    rssis <- numeric()
    dists <- numeric()
    rssimeans <- numeric()
    sds <- numeric()
    cnt <- 0
    for (i in 1:length(dm)) {
      rssimeans[i] <- mean(dm[[i]])
      sds[i]<-(sd(dm[[i]]))
      for(j in 1:length(dm[[i]])) {
        cnt <- cnt+1
        dists[cnt] <- i
        rssis[cnt] <- dm[[i]][j]
      }
    }

    lin <- lm(dists ~ rssis)

    postscript(paste("plotRssiDistInside",radio[ii,1],".ps"))                                                                    #60
    plot(rssis,dists,xlab="lqis",ylab="distance",main=paste("rssi vs dist INSIDE @ radiolevel ",radio[ii,1]),col="red1",ylim=c(0,10),xlim=c(70,130),pch="+",sub=paste("reg rmse = ",sqrt(mean(lin$residuals^2))))
    points(rssimeans,1:length(dm),col="blue1",type="l")
    points(rssimeans+sds,1:length(dm),col="green1",type="l")
    points(rssimeans-sds,1:length(dm),col="green1",type="l")
    abline(lin$coefficients,col="black",lwd=3)
    dev.off()
  }
}

plotRssiDistOutside <-function(radio = rbind(31,27,23,19,15,11,7,3)) {
  for (ii in 1:length(radio)) {
    #browser()

    dm <- getRssiDistMatOutside(radio[ii,1])

    rssis <- numeric()
    rssimeans <- numeric()
    sds <- numeric()
    dists <- numeric()
    cnt <- 0
    for (i in 1:length(dm)) {
      rssimeans[i] <- mean(dm[[i]])
      sds[i]<-(sd(dm[[i]]))
      for(j in 1:length(dm[[i]])) {
        cnt <- cnt+1
        dists[cnt] <- i
        rssis[cnt] <- dm[[i]][j]
      }
    }

    lin <- lm(dists ~ rssis)

    postscript(paste("plotRssiDistOutside",radio[ii,1],".ps"))                                                                          #ylim=c(0,60),
    plot(rssis,dists,xlab="lqis",ylab="distance",main=paste("rssi vs dist OUTSIDE @ radiolevel ",radio[ii,1]),col="red1",xlim=c(70,130),ylim=c(0,10),pch="+",sub=paste("reg rmse = ",sqrt(mean(lin$residuals^2))))
    points(rssimeans,1:length(dm),col="blue1",type="l")
    points(rssimeans+sds,1:length(dm),col="green1",type="l")
    points(rssimeans-sds,1:length(dm),col="green1",type="l")
    abline(lin$coefficients,col="black",lwd=3)
    dev.off()
  }
}

plotRssiDistBib1 <- function() {
  rssis <- numeric()
  dists <- numeric()

  #len <- length(bib1$lqi)
  len <- 1000
  for (i in 1:len) {
    if (bib1$src[i] > 1 & bib1$pongsrc[i] > 1) {
      rssis[i] <- bib1$rssi[i]
      dists[i] <- distanceBib1(bib1$src[i],bib1$pongsrc[i])
    }
  }

    lin <- lm(dists ~ rssis)

  pdf("plotRssiDistBib1.pdf")
  plot(rssis,dists,xlab="RSSI values (dBm)",ylab="Distance between node(m)",main=("Distance vs RSSI"),col="red1",ylim=c(0,8),pch="+")
  abline(coef=lin$coefficients)
  dev.off()
}

##########################################################################
#     LQI - VAR - MEAN
##########################################################################

tableLqiSymmetryBib1 <- function() {
  m <- tableLqiMeanBib1(1:100)
  d <- matrix(0,20,20)
  for (i in 1:19) {
    for (j in (i+1):20) {
      d[i,j] <- abs(m[i,j] - m[j,i])
      d[j,i] <- d[i,j]
    }
  }
  d
}

tableLqiSymmetrySer <- function() {
  m <- tableLqiMeanSer(1:100)
  d <- matrix(0,20,20)
  for (i in 1:19) {
    for (j in (i+1):20) {
      d[i,j] <- abs(m[i,j] - m[j,i])
      d[j,i] <- d[i,j]
    }
  }
  d
}



tableLqiVarianceBib1 <- function(){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- bib1$lqi[bib1$src==i & bib1$pongsrc==j & bib1$time <=25]
        if (length(sel) != 0) {
          m[i,j] <- round(var(sel),2)
        }
      }
    }
  }
  m
}



tableLqiVarianceSer <- function(){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- ser$lqi[ser$src==i & ser$pongsrc==j & ser$time <=25]
        if( length(sel) != 0 ){
          m[i,j] <- round(var(sel),2)
        }
      }
    }
  }
  m
}

tableLqiMeanBib1 <- function(samples=1:10){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- bib1$lqi[bib1$src==i & bib1$pongsrc==j & bib1$time <=25]
        if( length(sel) != 0 ){
          sel2 <- sel[samples]
          m[i,j] <- round(mean(sel2),2)
        }
      }
    }
  }
  m
}

tableLqiMeanSer <- function(samples=1:10){
  m <- matrix(0,20,20)
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- ser$lqi[ser$src==i & ser$pongsrc==j & ser$time <=25]
        if( length(sel) != 0 ){
          sel2 <- sel[samples]
          m[i,j] <- round(mean(sel2),2)
        }
      }
    }
  }
  m[,9] <- 0
  m
}

plotMeanLqiSerBib1 <- function(sel=1:100){
  x <- seq(1, 20)
  y <- x

  pdf("mean_lqi_SER.pdf")
  persp(x, y, tableLqiMeanSer(sel), theta = 30, phi = 30, expand = 0.5, col = "grey80",
  ltheta = 120, shade = 0.75, ticktype = "detailed",
  xlab = "node id A", ylab = "node id B", zlab = "var lqi",
  main="lqi mean all node to all nodes SER")
  dev.off()
  
  pdf("mean_lqi_BIB1.pdf")
  persp(x, y, tableRssiMeanBib1(sel), theta = 30, phi = 30, expand = 0.5, col = "grey80",
  ltheta = 120, shade = 0.75, ticktype = "detailed",
  xlab = "node id A", ylab = "node id B", zlab = "var lqi" ,
  main="lqi mean all node to all nodes BIB1")
  dev.off()

}

plotVarLqiSerBib1 <- function(){
  x<-numeric(400)
  y<-numeric(400)
  for (i in 1:20) {
    for (j in 1:20) {
      x[i+20*(j-1)] <- i
      y[i+20*(j-1)] <- j
    }
  }

  t1 <- tableLqiVarianceSer()
  t2 <- tableLqiVarianceBib1()

  t1 = t1/max(t1)
  t2 = t2/max(t2)

  #browser()

  pdf("var_lqi_BIB1.pdf")
  symbols(x[1:400], y[1:400], circles=t1[1:400], inches=FALSE,
        main="lqi var all node to all nodes SER", xlab="node id from", ylab="node id to")
  abline(a=0,b=1)
  dev.off()

  pdf("var_lqi_SER.pdf")
  symbols(x[1:400], y[1:400], circles=t2[1:400], inches=FALSE,
        main="lqi var all node to all nodes BIB1", xlab="node id from", ylab="node id to")
  abline(a=0,b=1)
  dev.off()
}

plotLqiVarianceDistBib1 <- function() {

 rs <- numeric()
 di <- numeric()
 cnt <- 0
  for (i in 2:20) {
    for (j in 2:20) {
      if(i!=j){
        sel <- bib1$lqi[bib1$src==i & bib1$pongsrc==j & bib1$time <=25]
        if (length(sel) > 0) {
          rs[cnt] <- var(sel)
          di[cnt] <- distanceBib1(i,j)
          cnt<-cnt+1
        }
      }
    }
  }
  pdf("lqi_var_vs_dist_BIB1.pdf")
  plot(rs,di,pch='+',main="lqi variance vs distance BIB1 25h",xlab="lqi var",ylab="dist")
  dev.off()
}

plotLqiSymmetry <- function() {
  val.se <- numeric()
  val.bi <- numeric()
  se <- tableLqiMeanSer()
  bi <- tableLqiMeanBib1()

  MID<-190
  cnt <- 1
  
  for (i in 1:19) {
    for (j in (i+1):20) {
      if(se[i,j] > se[j,i]) {
        val.se[MID-cnt] <- se[i,j] - se[j,i]
        val.se[MID+cnt] <- 0
      } else {
        val.se[MID+cnt] <- se[j,i] - se[i,j]
        val.se[MID-cnt] <-0
      }

      if(bi[i,j] > bi[j,i]) {
        val.bi[MID-cnt] <- bi[i,j] - bi[j,i]
        val.bi[MID+cnt] <- 0
      } else {
        val.bi[MID+cnt] <- bi[j,i] - bi[i,j]
        val.bi[MID-cnt] <-0
      }

      cnt <- cnt + 1
    }

  }
  
  pdf("lqi_symmetry.pdf")
  par(mfrow=c(2,1))
  
  plot(val.se,type="l",main="symmtrie lqi SER",col="blue1",ylim=c(0,10))
  abline(v=190,col="red1",lty=3)

  plot(val.bi,type="l",main="symmtrie lqi BIB1",col="blue1",ylim=c(0,10))
  abline(v=190,col="red1",lty=3)
  dev.off()


}

plotLqiSymmetry3D <- function() {
  x <- seq(1, 20)
  y <- x

  se <- tableLqiSymmetrySer()
  bi <- tableLqiSymmetryBib1()
  
  #se <- se / max(se)
  #bi <- bi / max(bi)

  #browser()

  pdf("lqi_symmetry_SER_3D.pdf")
  persp(x, y, se, theta = -45, phi = 45, expand = 0.5, col = "grey80",
  ltheta = -45, shade = 0.50, ticktype = "detailed",zlim=c(0,10),
  xlab = "node id A", ylab = "node id B", zlab = "assimetry |A-B|",
  main="lqi symmetry all node to all nodes SER")
  dev.off()

  pdf("lqi_symmetry_BIB1_3D.pdf")
 persp(x, y, bi, theta = -45, phi = 45, expand = 0.5, col = "grey80",
  ltheta = -45, shade = 0.50, ticktype = "detailed",zlim=c(0,10),
  xlab = "node id A", ylab = "node id B", zlab = "assimetry |A-B|",
  main="lqi symmetry all node to all nodes BIB1")
  dev.off()

}

plotLQIVarSameDistDifNodes<-function() {
	
	#toutes les paire(group1.s[i],group1.d[i]) sont  la mme distance dans BIB1
	groupS<-c(4,3,2,10,9,8)
	groupD<-c(11,10,9,18,17,16)
	groupL<-6
	
	pdf("plotLQIVarSameDistDifNodes.pdf")
	plot(NULL,NULL,type="n",xlim=c(0,100),ylim=c(50,110),xlab="mesures",ylab="LQI")	
	for (i in 1:groupL) {
		sel <- (bib1$src == bib1nodes[groupS[i]] & bib1$pongsrc == bib1nodes[groupD[i]]) | (bib1$src == bib1nodes[groupD[i]] & bib1$pongsrc == bib1nodes[groupS[i]] )
		
		valshow <- sample(bib1$lqi[sel],100,F)
		
		points(valshow,col=hsv(i/groupL,0.8,1),pch='+')
	}
	dev.off()
}

plotRSSIVarSameDistDifNodes<-function() {
	
	#toutes les paire(group1.s[i],group1.d[i]) sont  la mme distance dans BIB1
	groupS<-c(4,3,2,10,9,8)
	groupD<-c(11,10,9,18,17,16)
	groupL<-6
	
	pdf("plotRSSIVarSameDistDifNodes.pdf")
	plot(NULL,NULL,type="n",xlim=c(0,100),ylim=c(0,-50))	
	for (i in 1:groupL) {
		sel <- (bib1$src == bib1nodes[groupS[i]] & bib1$pongsrc == bib1nodes[groupD[i]]) | (bib1$src == bib1nodes[groupD[i]] & bib1$pongsrc == bib1nodes[groupS[i]] )
		
		valshow <- sample(bib1$rssi[sel],100,F)
		
		points(valshow,col=hsv(i/groupL,0.8,1),pch='+')
	}
	dev.off()
}




##########################################################################
#     LQI - TIME
##########################################################################
plotLqiTimeInside <- function(radio = rbind(31,27,23,19,15,11,7,3)){
  for (i in 1:length(radio)) {
    sel <- inpIn$radioLevel == radio[i,1]

    timeValues <- inpIn$time[sel]-min(inpIn$time[sel])
    lqiValues <- inpIn$lqi[sel]

    postscript(paste("plotLqiTimeInside",radio[i,1],".ps"))
    plot(lqiValues,timeValues,col="red1",pch="+",ylim=c(0,5000000),main=paste("lqi vs time  INSIDE @ radiolevel",radio[i,1]),xlab="lqi",ylab="time")
    dev.off()

 }
}

plotLqiTimeInsideAll <- function() {
    timeValues <- inpIn$time

    lis <- getTimeSlicesInside()

    postscript("plotLqiTimeInsideAll.ps")
    plot(inpIn$lqi,timeValues,col="red1",pch="+",main="lqi vs time  INSIDE ALL radiolevels",xlab="lqi",ylab="time")#,ylim=c(0,2000000)
    for(i in 1:length(lis)) {
      abline(h=lis[[i]][1])
      text(50,lis[[i]][1],i)
    }
    dev.off()
}

plotLqiTimeOutsideAll <- function() {
  timeValues <- inpOut$time

  lis <- getTimeSlicesOutside()

  postscript("plotLqiTimeOutsideAll.ps")
  plot(inpOut$lqi,timeValues,col="red1",pch="+",main="lqi vs time  OUTSIDE ALL radiolevels",xlab="lqi",ylab="time")
  for(i in 1:length(lis)) {
    abline(h=lis[[i]][1])
    text(50,lis[[i]][1],i)
  }
  dev.off()
}

plotLqiTimeOutside <- function(radio = rbind(31,27,23,19,15,11,7,3)){
  for (i in 1:length(radio)) {
    sel <- inpOut$radioLevel == radio[i,1]

    timeValues <- inpOut$time[sel]
    lqiValues <- inpOut$lqi[sel]

    postscript(paste("plotLqiTimeOutside",radio[i,1],".ps"))
    plot(lqiValues,timeValues,col="red1",pch="+",main=paste("lqi vs time  OUTSIDE @ radiolevel",radio[i,1]),xlab="lqi",ylab="time")
    dev.off()
  }
}

plotLqiTimeSer<-function(from=c(2,3,4),to=c(19,15,6)) {
  pdf("lqi_time_SER.pdf")
  par(mfrow=c(length(from),1))

  for (i in 1:length(from)) {

    sel <- ser$src==from[i] & ser$pongsrc==to[i]
    lqis <- ser$lqi[sel]
    times <- ser$time[sel]

    #browser()
    plot(times,lqis,
    xlab="temps(h)",ylab="lqi",
    xlim=c(0,60),
    ylim=c(50,110),
    col=hsv(i/length(from),.8,1),
    pch="+",
    main=paste("lqi - temps noeuds",from[i],"->",to[i],"SER")
    );
  }
  dev.off()
}

plotLqiTimeBib1<-function(from=c(7,8,9),to=c(10,11,12)) {
  pdf("lqi_time_BIB1.pdf")
  par(mfrow=c(length(from),1))

  for (i in 1:length(from)) {

    sel <- bib1$src==from[i] & bib1$pongsrc==to[i]
    lqis <- bib1$lqi[sel]
    times <- bib1$time[sel]

    #browser()
    plot(times,lqis,
    xlab="temps(h)",ylab="lqi",
    xlim=c(0,60),
    ylim=c(50,110),
    col=hsv(i/length(from),.8,1),
    pch="+",
    main=paste("lqi - temps noeuds",from[i],"->",to[i],"BIB1")
    );
  }
  dev.off()
}

plotLqiTimeBib2<-function(from=c(2,20,4,10,2,3),to=c(20,2,10,4,3,2)) {


  x11()
  lqis<-c(1,1,1)
  times<-c(1,1,1)
  #browser()
  plot(times,lqis,col="green1",type="n",xlab="",ylab="",axes=F,xlim=c(min(bib1$time),max(bib1$time)),ylim=c(min(bib1$lqi),max(bib1$lqi)))

  for(i in 1:length(from)){
    sel <- bib1$src==from[i] & bib1$pongsrc==to[i]
    lqis <- bib1$lqi[sel]
    times <- bib1$time[sel]
    #browser()
    points(times,lqis,col=hsv(i/length(from),.8,1),pch="+")
  }

  axis(1)
  axis(2)
  box()
  title(main="lqi vs time multiples nodes BIB2",xlab="times",ylab="lqis")
  legend(x = min(bib1$time), y = 150, col = hsv(1:length(from)/length(from),.8,1) ,pch = "+", lty = 1,legend = c(paste("from",from,"to",to)))

}



##########################################################################
#     LQI - DISTANCE
##########################################################################
getLqiDistMatInside <-function(rl=31) {
  sel <- inpIn$radioLevel == rl
  timeValues <- inpIn$time[sel]
  lqiValues <- inpIn$lqi[sel]

  retList <- list()
  slices <- getTimeSlicesInside()
  for (i in 1:length(slices)) {
    tmp <- lqiValues[timeValues > slices[[i]][1] & timeValues < slices[[i]][2]]
    if (length(tmp) == 0) {
        retList[[i]] <- c(0,0)
    } else {
      retList[[i]] <- tmp
    }
  }
  retList
  #browser()
}

getLqiDistMatOutside <-function(rl=31) {
  sel <- inpOut$radioLevel == rl
  timeValues <- inpOut$time[sel]
  lqiValues <- inpOut$lqi[sel]

  retList <- list()
  slices <- getTimeSlicesOutside()
  for (i in 1:length(slices)) {
    tmp <- lqiValues[timeValues > slices[[i]][1] & timeValues < slices[[i]][2]]
    if (length(tmp) == 0) {
        retList[[i]] <- c(0,0)
    } else {
      retList[[i]] <- tmp
    }
  }
  retList
}

plotLqiDistInside <-function(radio = rbind(31,27,23,19,15,11,7,3)) {
  for (ii in 1:length(radio)) {
    #browser()

    dm <- getLqiDistMatInside(radio[ii,1])

    lqis <- numeric()
    dists <- numeric()
    lqimeans <-numeric()
    sds <- numeric()
    cnt <- 0
    for (i in 1:length(dm)) {
      lqimeans[i] <- mean(dm[[i]])
      sds[i]<-(sd(dm[[i]]))
      for(j in 1:length(dm[[i]])) {
        cnt <- cnt+1
        dists[cnt] <- i * 100
        lqis[cnt] <- dm[[i]][j]
      }
    }
    

    lin <- lm(dists ~ lqis)

    pdf(paste("plotLqiDistInside",radio[ii,1],".pdf"))                                                                    #60    #xlim=c(50,110),
    plot(lqis,dists,xlab="lqis",ylab="distance",main=paste("lqi vs dist INSIDE @ radiolevel ",radio[ii,1]),col="red1",ylim=c(0,6000),pch=20,sub=paste("reg rmse = ",sqrt(mean(lin$residuals^2))))
    points(lqimeans,1:length(dm),col="blue1",type="l")
    #points(lqimeans+sds,1:length(dm),col="green1",type="l")
    #points(lqimeans-sds,1:length(dm),col="green1",type="l")
    abline(lin$coefficients,col="black",lwd=3)
    print(lin$coefficient)
    dev.off()
  }
}



plotLqiDistOutside<-function(radio = rbind(31,27,23,19,15,11,7,3)) {
  for (ii in 1:length(radio)) {
    #browser()

    dm <- getLqiDistMatOutside(radio[ii,1])

    lqis <- numeric()
    dists <- numeric()
    lqimeans <-numeric()
    sds <- numeric()
    cnt <- 0

    for (i in 1:length(dm)) {
      lqimeans[i] <- mean(dm[[i]])
      sds[i]<-(sd(dm[[i]]))
      for(j in 1:length(dm[[i]])) {
        cnt <- cnt+1
        dists[cnt] <- i
        lqis[cnt] <- dm[[i]][j]
      }
    }

    lin <- lm(dists ~ lqis)

    #browser()

    pdf(paste("plotLqiDistOutside",radio[ii,1],".pdf"))                                                             #0,60          #xlim=c(50,110),
    plot(lqis,dists,xlab="lqis",ylab="distance",main=paste("lqi vs dist OUTSIDE @ radiolevel ",radio[ii,1]),col="red1",ylim=c(0,40),xlim=c(50,110),pch=20)
    points(lqimeans,1:length(dm),col="blue1",type="l")
    #points(lqimeans+sds,1:length(dm),col="green1",type="l")
    #points(lqimeans-sds,1:length(dm),col="green1",type="l")
    abline(lin$coefficients,col="black",lwd=3)
    dev.off()
  }
}


plotLqiDistBib1 <- function() {
  lqis <- numeric()
  dists <- numeric()

  #len <- length(bib1$lqi)
  len <- 1000
  for (i in 1:len) {
    if (bib1$src[i] > 1 & bib1$pongsrc[i] > 1) {
      lqis[i] <- bib1$lqi[i]
      dists[i] <- distanceBib1(bib1$src[i],bib1$pongsrc[i])
    }
  }

    lin <- lm(dists ~ lqis)
	
  pdf("plotLqiDistBib1.pdf")
  plot(lqis,dists,xlab="Raw LQI Measurement",ylab="Distance between nodes(m)",main=("Distance vs LQI"),col="red1",ylim=c(0,8),pch="+")
  abline(coef=lin$coefficients)
  dev.off()
}

plotLqiDistBib2 <- function() {




}


##########################################################################
#     SOME TESTS
##########################################################################

testDependanceLqiVarAndLight<-function(instants=100,lqis,lights1,lights2,times1,times2) {
  lqivar <- numeric()
  light1mean <- numeric()
  light2mean <- numeric()

  jump <- (min(max(times1),max(times2))) / instants
  browser()

  j <- 0
  for (i in 1:instants) {
    interval1 <- times1 >= j & times1 < j+jump
    interval2 <- times2 >= j & times2 < j+jump
    #browser()
    if (length(lqis[interval1] > 0) & length(lights1[interval2]) > 0 & length(lights2[interval2]) > 0 ) {
      lqivar[i]<- var(lqis[interval1])
      light1mean[i]<- mean(lights1[interval2])
      light2mean[i]<- mean(lights2[interval2])
    }
    j <- j+jump
  }

  plot(lqivar,type="n",ylab="",xlab="",axes=F,xlim=c(0,instants))
  box()
  axis(1)
  axis(2)
  points(lqivar,type="l",col="green1")
  points(light1mean,type="l",col="red1")
  points(light2mean,type="l",col="blue1")

  x11()
  plot(lqivar,light1mean,col="red1",pch="+")
  x11()
  plot(lqivar,light2mean,col="blue1",pch="+")

}

testDependanceLqiVarAndLightBib1 <- function(nodeid=14,nodeid2=18){
  times1 <- (bib1$time[bib1$src==nodeid & bib1$pongsrc==nodeid2]) - min(bib1$time[bib1$src==nodeid & bib1$pongsrc==nodeid2])
  times2 <- bib1datas$time[bib1datas$nodeid==nodeid] - min(bib1datas$time[bib1datas$nodeid==nodeid])

  times1 <- times1 / 3600000
  times2 <- times2 / 3600000

  #browser()

  testDependanceLqiVarAndLight(100,
    bib1$lqi[bib1$src==nodeid & bib1$pongsrc==nodeid2],
    bib1datas$par[bib1datas$nodeid==nodeid],
    bib1datas$tsr[bib1datas$nodeid==nodeid],
    times1,
    times2)
}

testDependanceLqiVarAndLightSer <- function(nodeid=14,nodeid2=18){
  times1 <- (ser$time[ser$src==nodeid & ser$pongsrc==nodeid2]) - min(ser$time[ser$src==nodeid & ser$pongsrc==nodeid2])
  times2 <- serdatas$time[serdatas$nodeid==nodeid] - min(serdatas$time[serdatas$nodeid==nodeid])

  times1 <- times1 / 3600000
  times2 <- times2 / 3600000

  #browser()

  testDependanceLqiVarAndLight(100,
    ser$lqi[ser$src==nodeid & ser$pongsrc==nodeid2],
    serdatas$par[serdatas$nodeid==nodeid],
    serdatas$tsr[serdatas$nodeid==nodeid],
    times1,
    times2)
}

covariance<-function(name="name",distance.values,lqi.values,rssi.values) {

cov.lqi <- cov(distance.values,lqi.values)
cov.rssi <- cov(distance.values,rssi.values)

cor.lqi <- cov.lqi / sqrt(var(distance.values)*var(lqi.values))
cor.rssi <- cov.rssi / sqrt(var(distance.values)*var(rssi.values))

print(paste("Covariance distance - lqi",cov.lqi))
print(paste("Correlation distance - lqi",cor.lqi))

print(paste("Covariance distance - rssi",cov.rssi))
print(paste("Correlation distance - rssi",cor.rssi))

}

#covarianceBIB1<-function() {
#
#  lqi.values <- bib1$lqi
#  rssi.values <- bib1$rssi
#  distances <- distanceBib1(
#
#}


############################################
#   REGRESSIONS LQI RSSI DIST
###########################################

#DROITE REGRESSION  MEANx LQI - DISTANCE
  #bib1

  #distIN

  #distOUT

#DROITE REGRESSION  MEANx RSSI - DISTANCE
  #bib1

  #distIN

  #distOUT

#DROITE REGRESSION  MEANx LQI - DISTANCE i-j=j-i
  #bib1

  #distIN

  #distOUT

#DROITE REGRESSION  MEANx RSSI - DISTANCE i-j=j-i
  #bib1

  #distIN

  #distOUT

#trouver le nombre de mesures de lqi rssi ncessaire a bonne rgression linaire
#avec bib1
#p-e autre xp distance ?

#REGRESSION MODELE RADIO RSSI

#REGRESSION MODELE RADIO LQI

#trouver le nombre de mesures de lqi rssi ncessaire a bonne rgression radio


