/*
 * Main.java
 *
 * Created on 8 mars 2007, 15:20
 *  Van der Haegen Mathieu
 */
package net.tinyos.mapviewer;


import javax.swing.*;
import javax.swing.text.*;

import java.awt.*;              //for layout managers and more
import java.awt.event.*;


/**
 *
 * @author dwarfy
 */
public class Main {

    /** Creates a new instance of Main */
    private static void createAndShowGUI() {
        MapContainerPanel Map = new MapContainerPanel();

        RefreshThread Ref = new RefreshThread(143);
        
        String lookAndFeel = null;
        //Make sure we have nice window decorations.
        lookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
        try {
            UIManager.setLookAndFeel(lookAndFeel);
        } catch (Exception e) { }

        //Create and set up the window.
        JFrame frame = new JFrame("Localisation Viewer");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.add(Map);

        //Display the window.
        frame.pack();
        frame.setVisible(true);

        Map.log("Starting RefreshThread");


        Ref.setRefreshObj(Map);
        Ref.start();

    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }

}

