/*
 * RefreshThread.java
 *
 * Created on 9 mars 2007, 13:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 */
package net.tinyos.mapviewer;


import net.tinyos.tools.RadioPowerMsg;

import net.tinyos.util.*;
import net.tinyos.message.*;
import javax.swing.*;
import java.io.IOException;

import java.awt.*; 


public class RefreshThread extends Thread{
    long minPrime;
    MapContainerPanel obj;
    short actRadio,newRadio;
    public RefreshThread(int mp) {
        minPrime=mp;
        actRadio=31;
    }



    public void setRefreshObj(MapContainerPanel o){
        obj = o;
    }
    
        public void run() {

         //1 create a new serial receiver
         obj.log("Starting SerialReceiver");
         SerialReceiver Ser = new SerialReceiver();
         Ser.setMap(obj);
         Ser.setRcv(obj.rcvPane);


         //2 Call to CALIBRATOR AND WAIT FOR FINISH
         obj.log("Starting Calibrator");
         Calibrator Calib = new Calibrator();
         Calib.setSerial(Ser);
         
         obj.setCalibrator(Calib);
         
         obj.log("Calibration estimated regression :");
         obj.log("intercept = ".concat(Float.toString(Calib.intercept)));
         obj.log("coef = ".concat(Float.toString(Calib.coef)));
         

        obj.log("Waiting for some messages from nodes");
        
        while(Ser.getNodeInfoList().size() < 10 ) {

                try {
                    Thread.sleep(2000);
                    obj.log("RefreshThread: waiting for nodeInfoMessages");
                } catch (Exception e) {
                    System.out.println("RefreshThread: can't sleep");
                }
         }


         //3 start the estimator and give him what he needs
         obj.log("Starting Estimator");
         Estimator Est = new Estimator();
         Est.setMap(obj);
         Est.setSerial(Ser);
         Est.setCalib(Calib);

        //4 Localisator
         obj.log("Starting Localisator");
         Localisator Loc = new Localisator();
         Loc.setEstimator(Est);

        //5 Start the Stabilisator and let him make his job
         obj.log("Starting Stabilisator");
         Stabilisator Stab = new Stabilisator();
         Stab.setLocalisator(Loc);
         obj.setStab(Stab);
         
         while (true) {
            try {
               Thread.sleep(Config.REFRESH_TIME);
            } catch (Exception e) {
                System.out.println("RefreshThread: can't sleep");
            }
            
            if(obj.historyCheck.isSelected()) {
                Stab.updatePaths();
            }
            
            while(obj.slider3.getValueIsAdjusting()) {}
            newRadio = (short)obj.slider3.getValue();
            if(actRadio != newRadio) {
                RadioPowerMsg msg = new RadioPowerMsg();
                msg.set_radio(newRadio);
                try {
                    Ser.getMote().send(MoteIF.TOS_BCAST_ADDR,msg);
                    obj.log("Setting nodes radio power to".concat(String.valueOf(newRadio)));
                }catch (IOException ioe) {
                    System.err.println("Warning: Got IOException sending reset message: "+ioe);
                    ioe.printStackTrace();
                } 
                actRadio=newRadio;
            }
                
          
            obj.refresh();
         }
         
    }



}


