/*
 * Stabilisator.java
 *
 * Created on 12 mars 2007, 10:23
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 */

package net.tinyos.mapviewer;

import java.lang.reflect.Array;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

public class Stabilisator {
    LinkedList<LinkedList<Coord>> buffer ;
   
    Localisator L;
    boolean running;
    
    //Last Coords are saved up to Config.NODE_PATH_SIZE
    //the latests are added to the end of the list
    //the first are erased to keep a constant count of items
    
    /** Creates a new instance of Stabilisator */
    public Stabilisator() {
       buffer = new LinkedList<LinkedList<Coord>>();
    }
    
    public void setLocalisator(Localisator Loc) {
        L = Loc;
    }
    
    public Coord[] getLastPaths() {
        Coord[] path = new Coord[Config.NUM_NODES];
        L.localiseLat();
        float[][] res = L.getNodesPos();
        for (int x=0;x<Config.NUM_NODES;x++) {
            path[x] = new Coord(res[x][0],res[x][1]);
        }
        return path;
    }
    
    public Coord[] getPath(short nodeId) {
        Coord[] path = new Coord[Config.NODE_PATH_SIZE];
        ListIterator it = buffer.get(Config.getNodeIdx(nodeId)).listIterator();
        
        int x=0;
        while (it.hasNext() && x<Config.NODE_PATH_SIZE) {
            path[x] = (Coord)it.next();
            x++;
        }
        return path;
    }
    
    public void init() {
        for (int x=0;x<Config.NODE_PATH_SIZE;x++) {
            //call Config.PATH_SIZE times Localisator.localiseLat
            L.localiseLat();
            float[][] res = L.getNodesPos();
            
            for (int y=0;y<Config.NUM_NODES;y++) {
                buffer.get(y).addFirst(new Coord(res[y][0],res[y][1]));
            }
            
            try {
                Thread.sleep(Config.REFRESH_TIME);
            } catch (Exception e) {
              System.out.println("init: couldn't sleep");  
            }
            
        }
    }
    
    public void updatePaths() {
        L.localiseLat();
        float[][] res = L.getNodesPos();        
        
        
           
        for (int y=0;y<Config.NUM_NODES;y++) {
            Coord lastbuf = buffer.get(Config.getNodeIdx(y)).getLast();
            Coord last = new Coord(res[y][0],res[y][1]);
            
            if (Coord.distance(lastbuf,last) > Config.STEP_MAX_DIST) {
                //adjust coord
            }
            
            buffer.get(y).removeLast();
            buffer.get(y).addFirst(new Coord(res[y][0],res[y][1]));            
        }
    }
   
}
