/*
 * Config.java
 *
 * Created on 12 mars 2007, 11:38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author dwarfy
 */
package net.tinyos.mapviewer;

public class Config {

    public static long REFRESH_TIME=10000;

    public static short GROUP_ID = 1;

    public static short NUM_ANCHORS = 9; //the number of anchors nodes
    public static short NUM_NODES = 1; //the number of nodes to be tracked

    public static short[] ANCHORS_IDS = {1,2,3,4,5,6,7,8,9}; //7
    public static short[] NODES_IDS = {10};



    public static long STEP_MAX_DIST = 400;

    //manually enter anchors coordinates
    public static float[][] ANCHORS_POS = {
        {-1500,2000,0},        //capteur n1 : etiq 0
        {-1500,0,0},              //capteur n2 : etiq 5
        {0,0,0},        //capteur n 3 : etiq 8
        {-950,500,0},  //capteur n4 : etiq 9
        {-750,-500,0},    //capteur n 5 : etiq 10
        {-750,2500,0},    //capteur n6 : etiq 11
        {0,1000,0},      //capteur n 7 : etiq 3
        {0,2000,0},    //capteur n 8 : etiq 4
        {-1500,1000,0},    //capteur n 9 : etiq 14

    };

    //the max x and y position value of a node (absolute value)
    public static int XMAX=10000;
    public static int YMAX=10000;


    //SWING DISPLAY PARAMETERS
    public static int VIEWPANE_SIZE = 600;

    public static int NODE_PATH_SIZE = 10;


    public static int MIN_NODE_WIDTH=1; //min node width in the view in pixels
    public static int MAX_NODE_WIDTH=30; //max node width in the view in pixels

    public static int RESO=100; //the resolution of the view

    public static double ZOOM_STEP=0.1;
    public static double ZOOM_MAX=1;
    public static double ZOOM_MIN=0.1;

    public static short LINE_WIDTH_AXIS = 3;

    public static int getNodeIdx(int id) {
        for (short x=0;x<NUM_NODES;x++) {
            if (NODES_IDS[x] == id) { return (int)x; }
        }
        return 0;
    }

    public static int getAnchorIdx(int id) {
        for (short x=0;x<NUM_ANCHORS;x++) {
            if (ANCHORS_IDS[x] == id) { return (int)x; }
        }
        return 0;
    }
    
    public static float Distance(int nodeIdA,int nodeIdB) {
        float a= (float) Math.sqrt( Math.pow(ANCHORS_POS[getAnchorIdx(nodeIdA)][0]-ANCHORS_POS[getAnchorIdx(nodeIdB)][0],2) 
                                    + Math.pow(ANCHORS_POS[getAnchorIdx(nodeIdA)][1]-ANCHORS_POS[getAnchorIdx(nodeIdB)][1],2) );
        System.out.println(Float.toString(a));
        return a;
    }


    /** Creates a new instance of Config */
    public Config() {

    }

}
