/*
 * Localisator.java
 *
 * Created on 8 mars 2007, 16:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.tinyos.mapviewer;

import Jama.*;
import net.tinyos.tools.NodeInfoMsg;

import java.util.LinkedList;
import java.util.ListIterator;


/**
 *
 * @author dwarfy
 */

//should have infos about anchors node.

public class Localisator {
    private float[][] nodesPos;
    private SerialReceiver Ser;
        
    /** Creates a new instance of Localisator */
    public Localisator() {
        nodesPos = new float[Config.NUM_NODES][3];
    }
    
    public void setSerial(SerialReceiver R) {
        Ser=R;
    }
    
    public void localiseLat() {
        int[] cnt = new int[Config.NUM_NODES];
        int idxN,idxA;
        NodeInfoMsg m;
        
        for (int x=0;x<Config.NUM_NODES;x++) {
            nodesPos[x][0]=0;
            nodesPos[x][1]=0;                    
        }
        
        ListIterator LI = Ser.getNodeInfoList().listIterator();
        while (LI.hasNext()) {
            m = (NodeInfoMsg)LI.next();
            idxN = Config.getNodeIdx(m.get_idN());
            idxA = Config.getAnchorIdx(m.get_idA());
            cnt[idxN]++;
            nodesPos[idxN][0]+= Config.ANCHORS_POS[idxA][0];
            nodesPos[idxN][1]+= Config.ANCHORS_POS[idxA][1];
        }
        
        for (int x=0;x<Config.NUM_NODES;x++) {
            nodesPos[x][0]/=cnt[x];
            nodesPos[x][1]/=cnt[x];
        }
    }

    public float[][] getNodesPos() {
        return nodesPos;
    }

}
