package net.tinyos.tools;

import java.io.*;
import net.tinyos.packet.*;
import net.tinyos.util.*;
import net.tinyos.message.*;
import java.awt.*;
import java.util.*;
import java.text.*;

public class Monitor {
    static int nbPacket=0;

    public static double convert(byte b) {
        double res=(double)b;
        if (res<0) res=256+res;
        return res;
    }


    public static void main(String args[]) throws IOException {
        if (args.length != 1) {
            System.err.println("usage: java net.tinyos.tools.Monitor <mode>  | <mode> = 1 -> display <mode>= 2 -> log <mode>= 3 -> both");
            System.exit(2);
        }

		int _mode;
		try {
			_mode = Integer.parseInt(args[0]);
		} catch (NumberFormatException e) {
			System.err.println("<mode> must be 1,2 or 3 using 3 by default");
			_mode = 3;
		}


        DecimalFormat fent = new DecimalFormat();
        fent.setMaximumFractionDigits(0);
        fent.setGroupingUsed(false);

        long startMillis = System.currentTimeMillis();
        long dayCurrentN=Math.round(System.currentTimeMillis()/86400000);
        long dayCurrentR=dayCurrentN;

		PrintWriter fileR=null,fileN=null;

		if (_mode==2 || _mode==3)
		{
			fileR=new PrintWriter(new BufferedWriter
						  (new FileWriter("distance" + startMillis+"_"+dayCurrentR+".txt")));

		}

        PacketSource reader = BuildSource.makePacketSource();
        if (reader == null) {
            System.err.println("Invalid packet source (check your MOTECOM environment variable)");
            System.exit(2);
        }


	      reader.open(PrintStreamMessenger.err);

	      int START = 10;
	      int D = 0;

          for (;;) {
			try {

            byte[] packet = reader.readPacket();
          	Dump.printPacket(System.out, packet);
            System.out.println("");



            if (packet.length == 34 && packet[START]==34) {
				//paquet de readings

				double id = convert(packet[START+D]);
				double rl = convert(packet[START+D+1]);
				double cnt = convert(packet[START+D+2]);
				double rssi = (packet[START+D+3]+128); //convert -> signed
				double lqi = packet[START+D+4];



                if (_mode == 1 || _mode == 3) {
					System.out.println("READING:*********");
					System.out.println("id = " + fent.format(id));
			        System.out.println("radio level = " + fent.format(rl));
					System.out.println("cnt = " + fent.format(cnt));
					System.out.println("rssi = " + fent.format(rssi));
					System.out.println("lqi = " + fent.format(lqi));
					System.out.println("*****************");
				}

				if (_mode == 2 || _mode == 3) {
					long dayCurrentNewR=Math.round(System.currentTimeMillis()/86400000);

					try {
						if (dayCurrentNewR>dayCurrentR) {
							fileR.close();
							fileR=new PrintWriter(new BufferedWriter
												 (new FileWriter("distance"+startMillis+"_"+dayCurrentNewR+".txt")));

							dayCurrentR=dayCurrentNewR;
						}


						long currentTime=System.currentTimeMillis();
						//READINGS FORMAT :
						 //TIMESTAMP ID RADIOLEVEL CNT RSSI LQI
						fileR.println(currentTime +
									 " " + fent.format(id) +
									 " " + fent.format(rl) +
									 " " + fent.format(cnt) +
									 " " + fent.format(rssi) +
									 " " + fent.format(lqi));
						fileR.flush();

					} catch (IOException exc) {
				    	System.err.println("Error on fileR : " + exc);
				    }
				}

          	}
          }
        catch (Exception e) {
            System.err.println("Error on : " + e + ": " + e.getMessage());
        }
        }
    }
}
